#!/bin/bash
#
# makebeds.sh
# ENRAGE
#
# example: ../commoncode/makebeds.sh mouse c2c12rna24R.comb.eland2 c2c12rna.24R ../mm9splices/knownGene.txt 

echo $0': version 1.0'

if [ -z "$1" ]
then
    echo 'makebeds.sh genome elandfile fileprefix knownGenefile'
    exit
fi

#create bed file of unique reads
python2.5 ../commoncode/maketrackfromeland2.py $2 $3 $3.uniqs.bed

#create bed file of multi reads
python2.5 ../commoncode/maketrackmulti.py $2 $3multi $3.multi.bed

#create bed file of spliced reads
python2.5 ../commoncode/remapSplicesEland2.py $4 $2 $3splices $3.splices.bed

# count the unique reads falling on the gene models ; the nomatch files are 
# mappable reads that fell outside of the Cistematic gene models and not the 
# unmappable of Eland (i.e, the "NM" reads)
python2.5 ../commoncode/geneMrnaCounts.py $1 $3.uniqs.bed $3.uniqs.count $3.nomatch.bed

